library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

package Aufg5_Pack is

-- Vereinbarung von neuen Datentypen
subtype sBit is std_logic;
subtype Bitvec2 is std_logic_vector(3 downto 0);
subtype HalbByte is  std_logic_vector(3 downto 0);
subtype Bitvec7 is std_logic_vector(6 downto 0);

-- Vereinbarung einer Funktion f? den 7-Segment-Decoder
function Hex2Seg7 (inp: in HalbByte) return Bitvec7;

end Aufg5_Pack;


package body Aufg5_Pack is

function Hex2Seg7  (inp : in HalbByte) return Bitvec7 is
   variable outp : Bitvec7;
begin

case inp is
	when "0000" => outp := "1000000";
	when "0001"	=> outp := "1111001";
	when "0010"	=> outp := "0100100";
	when "0011"	=> outp := "0110000";
	when "0100"	=> outp := "0011001";
	when "0101"	=> outp := "0010010";
	when "0110"	=> outp := "0000010";
	when "0111"	=> outp := "1111000";
	when "1000"	=> outp := "0000000";
	when "1001"	=> outp := "0010000";
	when "1010"	=> outp := "0001000"; -- 'A'
	when "1011"	=> outp := "0000011";
	when "1100"	=> outp := "1000110";
	when "1101"	=> outp := "0100001";
	when "1110"	=> outp := "0000110";
	when others => outp := "0001110"; -- 'F'
end case;

return outp;
end Hex2Seg7;

end Aufg5_Pack; 